var/tmp/list/iconcache = list()
obj/temp
atom
	name = ""
	var
		color1
		effect1
		color2
		effect2
		color3
		effect3
		color4
		effect4
		color5
		effect5
		color6
		effect6
		color7
		effect7
		color8
		effect8
	proc
		locloc()
			return src
		iconcheck(refresh,icon/I,state)
			if(!refresh&&"[src.type][src.color1][src.color2]:icon" in iconcache)
				I = iconcache["[src.type][src.color1][src.color2]:icon"]
			else
				if(!I) I = new(initial(src.icon))
				else if(state) I = icon(I,state)
				else I = icon(I)
				if(color1) I = iconmod(I,"red",src.color1,src.effect1)
				if(color2) I = iconmod(I,"yellow",src.color2,src.effect2)
				if(color3) I = iconmod(I,"green",src.color3,src.effect3)
				if(color4) I = iconmod(I,"blue",src.color4,src.effect4)
				if(color5) I = iconmod(I,"cyan",src.color5,src.effect5)
				if(color6) I = iconmod(I,"magenta",src.color6,src.effect6)
				if(color7) I = iconmod(I,"orange",src.color7,src.effect7)
				if(color8) I = iconmod(I,"gray",src.color8,src.effect8)
				if(!refresh) iconcache["[src.type][src.color1][src.color2]:icon"] = I
			src.icon = I
			if(!src.icon)
				return
			if("0,0" in icon_states(I))
				if(!refresh&&"[src.type][src.color1][src.color2]:overlays" in iconcache)
					src.overlays = iconcache["[src.type][src.color1][src.color2]:overlays"]
				else
					src.overlays = null
					bigicon(I)
					if(!refresh) iconcache["[src.type][src.color1][src.color2]:overlays"] = src.overlays.Copy()
	movable
		locloc()
			while(!isturf(src)&&src)
				src = src.loc
			return src
proc
	between(a,b,c)
		if(a > b && a > c) return 0
		if(a < b && a < c) return 0
		return 1
	anim(image,loc,time,justme,below=-1,pixel_y,pixel_x,icon_state)
		if(!time)
			time = 10
		var/image/i = image(image,loc,icon_state)
		if(loc) i.layer = loc:layer-(0.1*below)
		i.pixel_y = pixel_y
		i.pixel_x = pixel_x
		if(!justme)
			world << i
		else
			justme << i
		spawn(time)
			del (i)
		return
	snd(sound,list/listeners,atom/src,f,c,repeat,p,e=2,v=100)
		var/sound/S
		if(listeners == "world")
			listeners = list()
			for(var/mob/M in world)
				listeners += M
		if(!istype(listeners,/list))
			listeners = list(listeners)
		if(istype(sound,/sound))
			S = sound
		else
			if(findtext("[sound]",".mid"))
				if(!c) c = 1
			S = new(sound)
		if(c==1)
			S.priority = 10
		else
			S.wait = 1
		if(p)
			S.priority = p
		if(e) S.environment = e
		if(f) S.frequency = f
		if(c) S.channel = c
		if(repeat)
			S.repeat = 1
		else
			S.repeat = 0
		if(v) switch(v)
			if("fadein")
				v = 0
				S.volume = v
				S.status = SOUND_STREAM+SOUND_UPDATE
				spawn
					while(v<100)
						v += 2
						S.frequency = 1
						S.volume = v
						playrelsound(S,src,listeners)
						sleep(1)
			if("fadeout")
				v = 100
				S.volume = v
				S.status = SOUND_STREAM+SOUND_UPDATE
				spawn
					while(v>0)
						v -= 2
						S.frequency = 1
						S.volume = v
						playrelsound(S,src,listeners)
						sleep(1)
			else
				S.volume = v
		playrelsound(S,src,listeners)
		return S
	playrelsound(sound/S,atom/src,list/listeners)
		if(src) for(var/mob/M in listeners)
			S.x = (src.x-M.x)/8
			S.y = (src.z-M.z)
			S.z = (src.y-M.y)/8
			M << S
		else
			listeners << S
		return
atom/proc
	iconstate(state,time,I=src.icon)
		if(!(state in icon_states(I)))
			return
		src.overlays = null
		if(time)
			spawn(time) if(src)
				src.overlays = null
				src.bigicon(I)
		src.bigicon(I,state)
		return
	bigicon(icon/I,state,image,l,p_x,p_y)
		if(!image) src.icon_state = state
		var
			obj/temp/O = new()
			list/L
			list/Q = list()
			maxx
			big
		if(isfile(I)||istype(I,/icon))
			L = list(I)
		else
			L = I
		if(!p_x)
			p_x = initial(pixel_x)
		if(!p_y)
			p_y = initial(pixel_y)
		if(!l) l=FLOAT_LAYER
		O.layer = l
		for(var/X in L)
			for(var/i in icon_states(X))
				if(findtext(i,",")&&findtext(i,state)&&!findtext(i,"port"))
					maxx = max(maxx,text2num(copytext(i,1,findtext(i,","))))
					big = 1
		for(var/X in L)
			if(!L[X]) L[X] = state
			O.icon = X
			if(big) for(var/i in icon_states(O.icon))
				if(findtext(i,",")&&findtext(i,L[X])&&findtext(i,state))
					O.icon_state = copytext(i,1,4)+(L[X])
					O.pixel_x = 32*text2num(copytext(i,1,findtext(i,",")))-maxx*16+p_x
					O.pixel_y = 32*text2num(copytext(i,findtext(i,",")+1))+p_y
					if(image) Q += image(O)
					else src.overlays += O
			else
				O.icon_state = state
				O.pixel_x = p_x
				O.pixel_y = p_y
				if(image) Q += image(O)
				else src.overlays += O
			spawn del(O)
		if(image) return Q
proc
	fontcolor(color,n=1)
		return iconmod("getcolor[n]","red",color)
	iconmod(icon/I,datum/src,trg,effect)
		if(!I||!src||!trg) return I
		if(src == "all")
			src = list(1,2,3,4,5,6,7,8)
		if(!istext(I))
			if(istype(src,/list))
				for(var/a in src)
					I = iconmod(I,a,trg,effect)
				return I
			I = icon(I)
		var
			src_a
			src_b
			src_c
			src_d
			trg_a
			trg_b
			trg_c
			trg_d
		switch(src)
			if("red",1)
				src_a = "#400000"
				src_b = "#800000"
				src_c = "#C00000"
				src_d = "#FF0000"
			if("yellow",2)
				src_a = "#404000"
				src_b = "#808000"
				src_c = "#C0C000"
				src_d = "#FFFF00"
			if("green",3)
				src_a = "#004000"
				src_b = "#008000"
				src_c = "#00C000"
				src_d = "#00FF00"
			if("blue",4)
				src_a = "#000040"
				src_b = "#000080"
				src_c = "#0000C0"
				src_d = "#0000FF"
			if("cyan",5)
				src_a = "#004040"
				src_b = "#008080"
				src_c = "#00C0C0"
				src_d = "#00FFFF"
			if("magenta",6)
				src_a = "#400040"
				src_b = "#800080"
				src_c = "#C000C0"
				src_d = "#FF00FF"
			if("orange",7)
				src_a = "#402000"
				src_b = "#803F00"
				src_c = "#C05F00"
				src_d = "#FF7F01"
			if("gray",8)
				src_a = "#202020"
				src_b = "#404040"
				src_c = "#606060"
				src_d = "#808080"
		switch(trg)
			if("red")
				trg_a = "#410101"
				trg_b = "#810101"
				trg_c = "#C10101"
				trg_d = "#FF0101"
			if("yellow")
				trg_a = "#515101"
				trg_b = "#A1A101"
				trg_c = "#D1D101"
				trg_d = "#FFFF01"
			if("green")
				trg_a = "#014101"
				trg_b = "#018101"
				trg_c = "#01C101"
				trg_d = "#01FF01"
			if("blue")
				trg_a = "#010141"
				trg_b = "#010181"
				trg_c = "#0101C1"
				trg_d = "#0101FF"
			if("cyan")
				trg_a = "#014141"
				trg_b = "#018181"
				trg_c = "#01C1C1"
				trg_d = "#01FFFF"
			if("magenta")
				trg_a = "#410141"
				trg_b = "#810181"
				trg_c = "#C101C1"
				trg_d = "#FF01FF"
			if("orange")
				trg_a = "#412001"
				trg_b = "#813F01"
				trg_c = "#C15F01"
				trg_d = "#FF7F02"
			if("darkgray")
				trg_a = "#010101"
				trg_b = "#212121"
				trg_c = "#414141"
				trg_d = "#616161"
			if("gray")
				trg_a = "#414141"
				trg_b = "#616161"
				trg_c = "#818181"
				trg_d = "#A1A1A1"
			if("lightgray")
				trg_a = "#818181"
				trg_b = "#A1A1A1"
				trg_c = "#C1C1C1"
				trg_d = "#E1E1E1"
			if("silver")
				trg_a = "#AAAAAA"
				trg_b = "#BBBBBB"
				trg_c = "#CCCCCC"
				trg_d = "#FEFEFE"
			if("steel")
				trg_a = "#666666"
				trg_b = "#999999"
				trg_c = "#CCCCCC"
				trg_d = "#EEEEEE"
			if("beige")
				trg_a = "#B49A54"
				trg_b = "#C8B580"
				trg_c = "#DBCFAD"
				trg_d = "#EFE9D9"
			if("platinum")
				trg_a = "#AABBAA"
				trg_b = "#BBCCBB"
				trg_c = "#CCDDCC"
				trg_d = "#EEFFEE"
			if("brown")
				trg_a = "#100C08"
				trg_b = "#3D2B1B"
				trg_c = "#6A4A2E"
				trg_d = "#966A42"
			if("lightbrown")
				trg_a = "#573C27"
				trg_b = "#765234"
				trg_c = "#A37047"
				trg_d = "#BF916B"
			if("brick")
				trg_a = "#110101"
				trg_b = "#210101"
				trg_c = "#410101"
				trg_d = "#810101"
			if("violet")
				trg_a = "#010141"
				trg_b = "#410181"
				trg_c = "#8101C1"
				trg_d = "#BF01FF"
			if("forest")
				trg_a = "#012101"
				trg_b = "#015101"
				trg_c = "#019101"
				trg_d = "#01BF01"
			if("white")
				trg_a = "#CCCCCC"
				trg_b = "#DDDDDD"
				trg_c = "#EEEEEE"
				trg_d = "#FEFEFE"
			if("black")
				trg_a = "#010101"
				trg_b = "#111111"
				trg_c = "#212121"
				trg_d = "#313131"
			if("gold")
				trg_a = "#907D00"
				trg_b = "#D0B500"
				trg_c = "#FFE011"
				trg_d = "#FFE851"
			if("rust")
				trg_a = "#400C08"
				trg_b = "#6D2B1B"
				trg_c = "#9A4A2E"
				trg_d = "#B66A42"
			if("bronze")
				trg_a = "#406C08"
				trg_b = "#6D8B1B"
				trg_c = "#9AAA2E"
				trg_d = "#B6CA42"
			if("sickly")
				trg_a = "#757059"
				trg_b = "#989276"
				trg_c = "#B4AF9A"
				trg_d = "#CFCCBF"
			if("palegreen")
				trg_a = "#667B53"
				trg_b = "#869F6F"
				trg_c = "#A6B995"
				trg_d = "#C6D3BB"
			if("pale")
				trg_a = "#E7B8AD"
				trg_b = "#EFD1C9"
				trg_c = "#F3DFD9"
				trg_d = "#F7E9E5"
			if("darkblue")
				trg_a = "#001E28"
				trg_b = "#004E68"
				trg_c = "#007FA8"
				trg_d = "#00AFE8"
			if("caucasian")
				trg_a = "#E2A39C"
				trg_b = "#E8B7B2"
				trg_c = "#EDC7C3"
				trg_d = "#ECD5D4"
			if("tan")
				trg_a = "#D88C5E"
				trg_b = "#DC9970"
				trg_c = "#E1AA89"
				trg_d = "#E4B396"
			if("negro")
				trg_a = "#331F0B"
				trg_b = "#523212"
				trg_c = "#714419"
				trg_d = "#78481A"
			if("olive")
				trg_a = "#4E341A"
				trg_b = "#7F5329"
				trg_c = "#B07338"
				trg_d = "#BC7B3C"
			if("blonde")
				trg_a = "#897D45"
				trg_b = "#B0A25E"
				trg_c = "#C5BA89"
				trg_d = "#DAD3B4"
			if("darkbrown")
				trg_a = "#140C06"
				trg_b = "#241C16"
				trg_c = "#4C3B2E"
				trg_d = "#634A37"
			if("deepbrown")
				trg_a = "#161002"
				trg_b = "#2D2103"
				trg_c = "#382604"
				trg_d = "#492E05"
			if("softgreen")
				trg_a = "#006300"
				trg_b = "#107704"
				trg_c = "#158615"
				trg_d = "#3CB715"
			if("darksoftgreen")
				trg_a = "#003300"
				trg_b = "#104704"
				trg_c = "#155615"
				trg_d = "#3C9715"
			if("hazel")
				trg_a = "#586E32"
				trg_b = "#68823A"
				trg_c = "#7B9A44"
				trg_d = "#9BBB63"
			if("lightblue")
				trg_a = "#2121FF"
				trg_b = "#6161FF"
				trg_c = "#A1A1FF"
				trg_d = "#D1D1FF"
			if("brightforest")
				trg_a = "#405C52"
				trg_b = "#4C8357"
				trg_c = "#91B83C"
				trg_d = "#AEC636"
			if("brightwood")
				trg_a = "#714F29"
				trg_b = "#876437"
				trg_c = "#B08549"
				trg_d = "#DBAD71"
			if("driftwood")
				trg_a = "#695761"
				trg_b = "#948087"
				trg_c = "#A89C9E"
				trg_d = "#C1B1B4"
			if("xotite")
				trg_a = "#AFD402"
				trg_b = "#97EE00"
				trg_c = "#E0FF11"
				trg_d = "#CAF87A"
			if("flame")
				trg_a = "#810000"
				trg_b = "#FFA201"
				trg_c = "#FEFE00"
				trg_d = "#FEFEFE"
			if("wallblastflame")
				trg_a = "#0000C0"
				trg_b = "#8080FF"
				trg_c = "#C0FFFF"
				trg_d = "#FEFEFE"
			if("pink")
				trg_a = "#FF3B3B"
				trg_b = "#FF6D6D"
				trg_c = "#FF9797"
				trg_d = "#FFC0C0"
			if("violetblast")
				trg_a = "#7213A3"
				trg_b = "#B34AEA"
				trg_c = "#E0AFF9"
				trg_d = "#F6E9FD"
			if("redblast")
				trg_a = "#610101"
				trg_b = "#A10101"
				trg_c = "#D10101"
				trg_d = "#FFEEEE"
			if("sewer")
				trg_a = "#19180C"
				trg_b = "#272B1D"
				trg_c = "#34301A"
				trg_d = "#444725"
			if("lightsewer")
				trg_a = "#29281C"
				trg_b = "#373B2D"
				trg_c = "#44402A"
				trg_d = "#545735"
			if("darksewer")
				trg_a = "#09080C"
				trg_b = "#171B0D"
				trg_c = "#24200A"
				trg_d = "#343715"
			if("ice")
				trg_a = "#3BFFFD"
				trg_b = "#6DFFFD"
				trg_c = "#8DFFFE"
				trg_d = "#C0FFFF"
			if("foliage")
				trg_a = "#1A2E00"
				trg_b = "#477E00"
				trg_c = "#62AE00"
				trg_d = "#7CDC00"
			if("darkgreen")
				trg_a = "#012101"
				trg_b = "#016101"
				trg_c = "#01A101"
				trg_d = "#01DF01"
			if("ash")
				trg_a = "#403E32"
				trg_b = "#64604E"
				trg_c = "#88836A"
				trg_d = "#A7A28B"
			if("darkash")
				trg_a = "#504E46"
				trg_b = "#5E5C54"
				trg_c = "#6E6C62"
				trg_d = "#7D7B6F"
			if("null")
				trg_a = null
				trg_b = null
				trg_c = null
				trg_d = null
			if("brightorange")
				trg_a = "#A32D00"
				trg_b = "#D94811"
				trg_c = "#EE5D26"
				trg_d = "#FF8E63"
			if("navy")
				trg_a = "#02005E"
				trg_b = "#03007A"
				trg_c = "#040098"
				trg_d = "#0400B4"
			if("softforest")
				trg_a = "#132F2D"
				trg_b = "#1D593B"
				trg_c = "#418713"
				trg_d = "#57930F"
			if("")
				trg_a = ""
				trg_b = ""
				trg_c = ""
				trg_d = ""
			if("")
				trg_a = ""
				trg_b = ""
				trg_c = ""
				trg_d = ""
		if(I=="getcolor1")
			return trg_a
		if(I=="getcolor2")
			return trg_b
		if(I=="getcolor3")
			return trg_c
		if(I=="getcolor4")
			return trg_d
		if(effect)
			var/icon/X = icon(I)
			var/icon/Y = icon(I)
			X.SwapColor(src_a,null)
			X.SwapColor(src_b,null)
			X.SwapColor(src_c,null)
			X.SwapColor(src_d,null)
			X.SetIntensity(0)
			Y.Blend(X,ICON_OVERLAY)
			Y.SwapColor("#000000",null)
			Y.SwapColor(src_a,trg_a)
			Y.SwapColor(src_b,trg_b)
			Y.SwapColor(src_c,trg_c)
			Y.SwapColor(src_d,trg_d)
			if(effect != "dither50")
				I.Blend(Y,ICON_OVERLAY)
			else
				I.SwapColor(src_a,null)
				I.SwapColor(src_b,null)
				I.SwapColor(src_c,null)
				I.SwapColor(src_d,null)
			X = icon(Y)
			switch(effect)
				if("riveted")
					Y.Blend('dmi/textures/tex_rivets1.dmi',ICON_ADD)
					I.Blend(Y,ICON_OVERLAY)
				if("flash")
					Y.Blend('dmi/textures/tex_flash1.dmi',ICON_ADD)
					I.Blend(Y,ICON_OVERLAY)
				if("strobe")
					Y.Blend('dmi/textures/tex_flash2.dmi',ICON_ADD)
					I.Blend(Y,ICON_OVERLAY)
				if("liquid")
					Y.Blend('dmi/textures/tex_liquid1.dmi',ICON_ADD)
					I.Blend(Y,ICON_OVERLAY)
				if("dither50")
					Y.Blend('dmi/textures/tex_dither50.dmi',ICON_ADD)
					I.Blend(Y,ICON_OVERLAY)
				if("pulse")
					Y.Blend('dmi/textures/tex_pulse1.dmi',ICON_ADD)
					I.Blend(Y,ICON_OVERLAY)
				if("phase")
					Y.Blend('dmi/textures/tex_phase1.dmi',ICON_ADD)
					I.Blend(Y,ICON_OR)
				if("uneven")
					Y.Blend('dmi/textures/tex_uneven1.dmi',ICON_ADD)
					I.Blend(Y,ICON_OVERLAY)
				if("gritty")
					Y.Blend('dmi/textures/tex_gritty1.dmi',ICON_ADD)
					I.Blend(Y,ICON_OVERLAY)
				if("stone")
					Y.Blend('dmi/textures/tex_stone1.dmi',ICON_ADD)
					I.Blend(Y,ICON_OVERLAY)
				if("darkstone")
					Y.Blend('dmi/textures/tex_stone1.dmi',ICON_SUBTRACT)
					I.Blend(Y,ICON_OVERLAY)
				if("stratifiedstone")
					Y.Blend('dmi/textures/tex_stone2.dmi',ICON_ADD)
					I.Blend(Y,ICON_OVERLAY)
				if("wood")
					Y.Blend('dmi/textures/tex_wood1.dmi',ICON_ADD)
					I.Blend(Y,ICON_OVERLAY)
				if("bubbly")
					Y.Blend('dmi/textures/tex_bubbly1.dmi',ICON_ADD)
					I.Blend(Y,ICON_OVERLAY)
				if("fire")
					var/f = 3
					for(var/i=f,i>0,i--)
						X.Shift(SOUTH,1)
						X.SetIntensity(1.5)
						X.Blend(Y,ICON_UNDERLAY)
					X.Shift(NORTH,f)
					Y.Blend(X,ICON_OVERLAY)
					Y.SetIntensity(0.25)
					Y.Blend('dmi/textures/tex_fire1.dmi',ICON_ADD)
					I.Blend(Y,ICON_OR)
				if("electric","icy","smokey")
					if(effect == "smokey")
						Y.Blend('dmi/textures/tex_smokey1.dmi',ICON_ADD)
					else if(effect == "icy")
						Y.Blend('dmi/textures/tex_crosshatch1.dmi',ICON_ADD)
					else
						Y.SetIntensity(1.5)
						Y.Blend('dmi/textures/tex_electric1.dmi',ICON_ADD)
					I.Blend(Y,ICON_OVERLAY)
					X.Shift(NORTH,2)
					X.Shift(WEST,2)
					Y.Blend(X,ICON_UNDERLAY)
					X.Shift(EAST,4)
					Y.Blend(X,ICON_UNDERLAY)
					X.Shift(SOUTH,4)
					Y.Blend(X,ICON_UNDERLAY)
					X.Shift(WEST,4)
					Y.Blend(X,ICON_UNDERLAY)
					if(effect == "smokey")
						Y.Blend('dmi/textures/tex_smokey1.dmi',ICON_ADD)
					else if(effect == "icy")
						Y.Blend('dmi/textures/tex_crosshatch1.dmi',ICON_ADD)
						Y.SwapColor(trg_a,null)
						Y.SwapColor(trg_b,null)
						Y.SwapColor(trg_c,null)
						Y.SwapColor(trg_d,null)
					else
						Y.SetIntensity(0.25)
						Y.Blend('dmi/textures/tex_electric1.dmi',ICON_ADD)
					I.Blend(Y,ICON_UNDERLAY)
				if("aura","flare")
					if(effect != "flare")
						Y.SetIntensity(1.5)
					else
						Y.SetIntensity(0.5)
						Y.Blend('dmi/textures/tex_flare1.dmi',ICON_ADD)
					I.Blend(Y,ICON_OVERLAY)
					X.Shift(NORTH,2)
					X.Shift(WEST,2)
					Y.Blend(X,ICON_UNDERLAY)
					X.Shift(EAST,4)
					Y.Blend(X,ICON_UNDERLAY)
					X.Shift(SOUTH,4)
					Y.Blend(X,ICON_UNDERLAY)
					X.Shift(WEST,4)
					Y.Blend(X,ICON_UNDERLAY)
					if(effect != "flare")
						Y.SetIntensity(10)
					else
						Y.SetIntensity(0.25)
						Y.Blend('dmi/textures/tex_flare1.dmi',ICON_ADD)
					I.Blend(Y,ICON_UNDERLAY)
				if("none")
					effect = null
				else
					world.log << "Unknown effect [effect]"
					effect = null
		if(!effect)
			I.SwapColor(src_a,trg_a)
			I.SwapColor(src_b,trg_b)
			I.SwapColor(src_c,trg_c)
			I.SwapColor(src_d,trg_d)
		return I
	importspritesheet(source,target,size_x=1,size_y=1,iconstate,moving,delay)
		var/maxx
		var/maxy
		for(var/i in icon_states(source))
			if(findtext(i,","))
				maxx = max(maxx,text2num(copytext(i,1,findtext(i,","))))
				maxy = max(maxy,text2num(copytext(i,findtext(i,",")+1)))
		if((maxx+1)%size_x||(maxy+1)%size_y)
			CRASH("Invalid Spritesheet! ([size_x]/[maxx]) ([size_y]/[maxy]) [source])")
		var/icon/I = icon(target)
		for(var/i in icon_states(source))
			if(findtext(i,","))
				var/thisx = text2num(copytext(i,1,findtext(i,",")))
				var/thisy = text2num(copytext(i,findtext(i,",")+1))
				var/thisdir
				var/thisframe = 1
				if(thisx != 0)
					thisframe = 1+round(thisx/size_x)
				if(maxy > size_y*5)
					if(thisy == 0)
						thisdir = NORTHWEST
					else switch(round(thisy/size_y))
						if(7) thisdir = SOUTH
						if(6) thisdir = NORTH
						if(5) thisdir = EAST
						if(4) thisdir = WEST
						if(3) thisdir = SOUTHEAST
						if(2) thisdir = SOUTHWEST
						if(1) thisdir = NORTHEAST
						else thisdir = NORTHWEST
				else if(maxy > size_y)
					if(thisy == 0)
						thisdir = WEST
					else switch(round(thisy/size_y))
						if(3) thisdir = SOUTH
						if(2) thisdir = NORTH
						if(1) thisdir = EAST
						else thisdir = WEST
				I.Insert(icon(source,icon_state=i),(size_x+size_y>2) ? "[thisx%size_x],[thisy%size_y][iconstate]" : iconstate,thisdir,thisframe,moving,delay)
			else if(!(iconstate in icon_states(I)))
				I.Insert(icon('dmi/misc/misc_noicon.dmi'),iconstate)
		I.SwapColor(rgb(192,192,192),null)
		return I
